// #autoload
// #name = StatTracker
// #version = 1.0
// #date = 8/21/02
// #author = |eX|DEbig3
// #warrior =  DEbig3
// #email = debig3@attbi.com
// #web = http://debig3.tribes2.org
// #description = keeps track of all your kills/deaths and allows you to set them as your player profile in the browser.
// #status = release
// #readme =

function statTrackerJoinedServer(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid) {
	if (strstr(%msgString, "Welcome to Tribes2") != -1) {
		$statTrackerName = detag(%clientName);
	}
}

function statTrackerKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
	%killer = detag(%killername);
	%victim = detag(%victimname);
	if (%killer $= $statTrackerName) {
		%weapon = $DamageTypeToName[%damageType];
		$pref::statTracker::kills[%weapon]++;
		$pref::statTracker::kills++;
	}
	else if (%victim $= $statTrackerName) {
		%weapon = $DamageTypeToName[%damageType];
		$pref::statTracker::deaths[%weapon]++;
		$pref::statTracker::deaths++;
	}
}

new GuiControl(statTrackerProfileUpdate);

function updateProfileStats() {
	%x = "1";
	%firsttime = true;
	%firsttime2 = true;
	%text = "<color:8484ff>Total Kills: <color:ffffff>" @ $pref::statTracker::kills @ "\n";
	%text = %text @ "<color:8484ff>Total Deaths <color:ffffff>" @ $pref::statTracker::deaths @ "\n";
	if (($pref::statTracker::kills) && ($pref::statTracker::deaths)) {
		%ratio = $pref::statTracker::kills / $pref::statTracker::deaths;
		%text = %text @ "<color:8484ff>Kill/Death ratio: <color:ffffff>" @ %ratio @ "\n\n";
	}
	while (%x <= "32") {
		%weapon = $DamageTypeToName[%x];
		if (($pref::statTracker::kills[%weapon] !$= "") && (%x > %y)) {
			%text = %text @ "<just:left><color:a3a6ff>" @ %weapon @ " kills: <color:ffffff>" @ $pref::statTracker::kills[%weapon];
		}
		else {
			if (%firsttime)
				%y = %x + 1;
			%firsttime = false;
			while (%y <= "32") {
				if ($pref::statTracker::kills[$DamageTypeToName[%y]] !$= "") {
					%text = %text @ "<just:left><color:a3a6ff>" @ $DamageTypeToName[%y] @ " kills: <color:ffffff>" @ $pref::statTracker::kills[$DamageTypeToName[%y]];
					%y++;
					break;
				}
				else
					%y++;
			}
		}			
		if (($pref::statTracker::deaths[%weapon] !$= "") && (%x > %z)) {
			%text = %text @ "<just:right><color:a3a6ff>" @ %weapon @ " deaths: <color:ffffff>" @ $pref::statTracker::deaths[%weapon] @ "\n";
		}
		else {
			if (%firsttime2)
				%z = %x + 1;
			%firsttime2 = false;
			while (%z <= "32") {
				if ($pref::statTracker::deaths[$DamageTypeToName[%z]] !$= "") {
					%text = %text @ "<just:right><color:a3a6ff>" @ $DamageTypeToName[%z] @ " deaths: <color:ffffff>" @ $pref::statTracker::deaths[$DamageTypeToName[%z]] @ "\n";
					%z++;
					break;
				}
				else
					%z++;
			}
		}
		%x++;
	}
	statTrackerProfileUpdate.editType = "warrior";
	canvas.SetCursor(ArrowWaitCursor);
	EditDescriptionText.setValue("<font:Arial:14><just:center>" @ %text);
	TProfileHdr.Desc = EditDescriptionText.getValue();
	statTrackerProfileUpdate.key = LaunchGui.key++;
	DatabaseQuery(17,TProfileHdr.Desc, statTrackerProfileUpdate, statTrackerProfileUpdate.key);
}

function statTrackerProfileUpdate::onDatabaseQueryResult(%this, %status, %resultString, %key) {
	if(getField(%status, 0) == 0) {
		WP_WarriorDescription.setText(EditDescriptionText.getValue());
		//messageBoxOK("yay", "profile stats have been updated");
	}
	else if (getSubStr(getField(%status, 1), 0, 9) $= "ORA-04061") {
		MessageBoxOK("shit", "it fucked up.");
	}
	else {
		messageBoxOK("er..", getField(%status,1) @ "\n\n" @ %resultString);
	}
	W_ProfilePane.setVisible(1);
	W_Profile.setValue(1);
	canvas.setCursor(defaultCursor);
}

function statTrackerAddPrettyButton() {
	%unf = new ShellRadioButton(saveStats) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "555 -2";
		extent = "85 30";
		minExtent = "26 27";
		visible = "0";
		command = "updateProfileStats();";
		helpTag = "0";
		text = "SAVE STATS";
		maxLength = "255";
		groupNum = "4";
	};
	PlayerPane.add(%unf);
}

package statTracker {
function DispatchLaunchMode() {
	parent::DispatchLaunchMode();
	addMessageCallBack('msgVehicleKill', statTrackerKill);
	addMessageCallBack('msgCTurretKill', statTrackerKill);
	addMessageCallBack('msgTurretKill', statTrackerKill);
	addMessageCallBack('MsgLegitKill', statTrackerKill);
	addMessageCallBack('MsgHeadshotKill', statTrackerKill);
	addMessageCallBack('msgTeamKill', statTrackerKill);
	addMessageCallback('MsgClientJoin', statTrackerJoinedServer);
}

function PlayerPane::onAdd(%this) {
	parent::onAdd(%this);
	statTrackerAddPrettyButton();
	%val = $statTrackerPlayerName $= TProfileHdr.PlayerName;
	saveStats.setVisible(%val);
}

function PlayerPane::onWake(%this) {
	parent::onWake(%this);
	%val = $statTrackerPlayerName $= TProfileHdr.PlayerName;
	saveStats.setVisible(%val);
}

function PlayerPane::onDatabaseQueryResult(%this,%status,%resultString,%key) {
	parent::onDatabaseQueryResult(%this,%status,%resultString,%key);
	%val = $statTrackerPlayerName $= TWBTitle.name;
	saveStats.setVisible(%val);
}

function TribeAndWarriorBrowserGui::onWake(%this) {
	parent::onWake(%this);
	%val = $statTrackerPlayerName $= TProfileHdr.PlayerName;
	saveStats.setVisible(1);
}
};
activatePackage(statTracker);
echo("statTracker v1.0 - DEbig3 > you.");
$statTrackerPlayerName = getField(getRecord(wonGetAuthInfo(), 0), 0);

if(!isObject(statTracker)) {
	new ScriptObject(statTracker) {
		class = statTracker;
	};
}

$DamageTypeToName["1"] = "Blaster";
$DamageTypeToName["2"] = "Plasma";
$DamageTypeToName["3"] = "Chaingun";
$DamageTypeToName["4"] = "Disc";
$DamageTypeToName["5"] = "Grenade";
$DamageTypeToName["6"] = "Laser";
$DamageTypeToName["7"] = "ELF";
$DamageTypeToName["8"] = "Mortar";
$DamageTypeToName["9"] = "Missile";
$DamageTypeToName["10"] = "Shocklance";
$DamageTypeToName["11"] = "Mine";
$DamageTypeToName["12"] = "Unused";
$DamageTypeToName["13"] = "Ramming";
$DamageTypeToName["14"] = "Unused";
$DamageTypeToName["15"] = "Turret";
$DamageTypeToName["16"] = "PlasmaTurret";
$DamageTypeToName["17"] = "AATurret";
$DamageTypeToName["18"] = "ELFTurret";
$DamageTypeToName["19"] = "MortarTurret";
$DamageTypeToName["20"] = "MissileTurret";
$DamageTypeToName["21"] = "SpiderClamp";
$DamageTypeToName["22"] = "Landspike";
$DamageTypeToName["23"] = "SentryTurret";
$DamageTypeToName["24"] = "Unused";
$DamageTypeToName["25"] = "Unused";
$DamageTypeToName["26"] = "ShrikeBlaster";
$DamageTypeToName["27"] = "BellyTurret";
$DamageTypeToName["28"] = "Bomb";
$DamageTypeToName["29"] = "TankChaingun";
$DamageTypeToName["30"] = "TankMortar";
$DamageTypeToName["31"] = "Satchel";
$DamageTypeToName["32"] = "MPBMissile";